package nocturne.jfly;

/**
 * To change this template use Options | File Templates.
 */
public interface IFlyLog
{
    /**
     *   
     */
    public class LogParameters
    {
        /**
         * 
         */
        private int _indent = 2;

        /**
         *    
         */
        private boolean _writeTimestamp = true;

        /**
         *    /  
         */
        private boolean _scopeAutoIndent = true;

        public int get_indent()
        {
            return _indent;
        }

        public void set_indent(int _indent)
        {
            this._indent = _indent;
        }

        public boolean is_writeTimestamp()
        {
            return _writeTimestamp;
        }

        public void set_writeTimestamp(boolean _writeTimestamp)
        {
            this._writeTimestamp = _writeTimestamp;
        }

        public boolean is_scopeAutoIndent()
        {
            return _scopeAutoIndent;
        }

        public void set_scopeAutoIndent(boolean _scopeAutoIndent)
        {
            this._scopeAutoIndent = _scopeAutoIndent;
        }

        public LogParameters(int _indent, boolean _writeTimestamp, boolean _scopeAutoIndent)
        {
            this._indent = _indent;
            this._writeTimestamp = _writeTimestamp;
            this._scopeAutoIndent = _scopeAutoIndent;
        }

        public LogParameters()
        {
        }
    }

    /*
     *  
     */

    // 
    public final static int NOTIFICATION = 1;

    // 
    public final static int ERROR = 2;

    //  
    public final static int OPEN_SCOPE = 3;

    //  
    public final static int CLOSE_SCOPE = 4;

    /**
     *   
     * @param parameters -  
     */
    public void set_parameters( LogParameters parameters );

    /**
     *   
     * @return   
     */
    public LogParameters get_parameters();

    /**
     *    
     *
     * @param automata -    
     * @param text -   
     */
    public void log( String automata, String text );

    /**
     *    
     *
     * @param automata -    
     * @param text -   
     * @param type -  
     */
    public void log( String automata, String text, int type );

    /**
     *  
     */
    public void indent();

    /**
     *  
     */
    public void unindent();
}
